package ee.websocknaozaj;

import jakarta.enterprise.context.ApplicationScoped;
import jakarta.inject.Named;

import java.util.Random;

@Named
@ApplicationScoped
public class Guess
{
    private int numberOfUsers;
    private int guessedNumber;
    Random rnd;
    private boolean isOpen;

    private final static int MAX_NUMBER = 100;

    public Guess()
    {
        rnd = new Random();
        guessedNumber = rnd.nextInt(MAX_NUMBER) + 1;
        isOpen = true;
    }

    public int getGuessedNumber()
    {
        return guessedNumber;
    }

    public void regenerateNumber()
    {
        guessedNumber = rnd.nextInt(MAX_NUMBER) + 1;
        isOpen = true;
    }

    public String getNumberOfUsers()
    {
        return Integer.toString(numberOfUsers);
    }

    public synchronized void addUser()
    {
        numberOfUsers++;
    }

    public synchronized void removeUser()
    {
        numberOfUsers--;
    }

    public void setNumberOfUsers(String num)
    {
        try {
            numberOfUsers = Integer.parseInt(num);
        } catch (Exception e) {}
    }

    public synchronized boolean close()
    {
        boolean wasOpen = isOpen;
        isOpen = false;
        return wasOpen;
    }

}