package ee.websocknaozaj;

import jakarta.enterprise.context.SessionScoped;
import jakarta.inject.Inject;
import jakarta.inject.Named;

import java.io.Serializable;

@Named
@SessionScoped
public class Userguess implements Serializable
{
    private int score;
    private String username;
    private int newguess;
    private String message;

    GameOverNotifier notifier;

    @Inject
    Guess guess;

    public Userguess()
    {
        newguess = -1;
        score = 0;
    }

    public void setNotifier(GameOverNotifier ep)
    {
        notifier = ep;
    }

    public void setUsername(String name)
    {
        username = name;
    }

    public String getUsername()
    {
        return username;
    }

    public void setNewguess(String newguessString)
    {
        try {
            newguess = Integer.parseInt(newguessString.trim());

            if (newguess < 0) message = "Make a guess!";
            else if (newguess < guess.getGuessedNumber())
                message = newguess + " is too little";
            else if (newguess > guess.getGuessedNumber())
                message = newguess + " is too much";
            else
            {
                if (guess.close())
                {
                    score++;
                    notifier.announce(2, username + " won, the number was " + guess.getGuessedNumber());
                }
                message = "Congratulations, the secret number was " + newguess;
            }

        } catch (Exception e) { System.out.println(e.getMessage());}
    }

    public String getNewguess()
    {
        return "";
    }

    public void setMessage(String msg)
    {
        message = msg;
    }

    public String getMessage()
    {
        return message;
    }

    public void restart()
    {
        guess.regenerateNumber();
        newguess = -1;
        notifier.announce(2, username + " has restarted the game");
    }

    public String getScore()
    {
        return Integer.toString(score);
    }

}